package jdwang.hadoop;
import java.io.IOException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import java.util.TreeMap;

import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Reducer;

//public class TDCS_MRP_Reducer extends Reducer<Text, Text, Text, Text> {
//public class TDCS_MRP_TimeInterval_Reducer_3 extends Reducer<Text, IntWritable, Text, IntWritable> {
public class TDCS_MRP_TimeInterval_Reducer_3 extends Reducer<Text, Text, Text, Text> {
    
	//private IntWritable result = new IntWritable();
	public void reduce(Text key, Iterable <Text> values, Context context) throws IOException, InterruptedException {
	//public void reduce(Text key, Iterable<IntWritable> values, Context context) throws IOException, InterruptedException {	
	// process values	
		///*
		TreeMap TimeIntervalDistribution = new TreeMap<Integer, Integer>();
		String Temp = "";
		int SumMin = 0;
		int SumTF = 0;
		int Max = 0;
		int Min = 1000000000;
		for (Text val : values) {
			//context.write(key, val);
			Temp = val.toString();
			//String CompositeValue = "Total_Min="+Integer.toString(TotalTime)+"##"+TF;
			String [] Items = Temp.split("##");
			Integer TotalTime = Integer.valueOf(Items[0].substring(10)); // the remainder substring after "Total_Min="
			if (TotalTime > Max) {
				Max = TotalTime;
			}
			if (TotalTime < Min) {
				Min = TotalTime;
			}
			
			Integer TF = Integer.valueOf(Items[1]);
			
			SumMin = SumMin + TotalTime*TF;
			SumTF = SumTF + TF;
			
			if (TimeIntervalDistribution.containsKey(TotalTime)) {
				Integer temp = (int) TimeIntervalDistribution.get(TotalTime) + TF;
				TimeIntervalDistribution.put(TotalTime, temp);
			} else {
				TimeIntervalDistribution.put(TotalTime, TF);
			}
		} // End of for (Text val : values)
		float AvgMin = SumMin/SumTF; 
		
		Set <Integer> Keys = TimeIntervalDistribution.keySet();
		
		String TotalTimeDistribution = "";
		for ( Iterator i = Keys.iterator(); i.hasNext();) {
		     Integer onekey = (Integer) i.next();
		     Integer value =  (Integer) TimeIntervalDistribution.get(onekey);
		     //System.out.println(key + " = " + value);
		     TotalTimeDistribution = TotalTimeDistribution+"(" + Integer.toString(onekey)+":"+Integer.toString(value)+")";
		 }
		
		
		
		Text ValueKey = new Text();
		String Result = "SumTF="+Integer.toString(SumTF)+"#"+"MaxT="+Integer.toString(Max)+"#"+"MinT="+Integer.toString(Min)+"#"+"AvgT="+String.valueOf(AvgMin)+"#"+TotalTimeDistribution;
		
		ValueKey.set(Result);
		
		context.write(key, ValueKey);
		
		//*/
		/*
		int sum = 0;
		for (IntWritable val : values) {
			sum += val.get();
		}
		result.set(sum);
		context.write(key, result);
		*/
	} //End of public void reduce
} // End of public class TDCS_MRP_Reducer extends Reducer
