package jdwang.hadoop;
import java.io.IOException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import java.util.TreeMap;

import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Reducer;

//public class TDCS_MRP_Reducer extends Reducer<Text, Text, Text, Text> {
//public class TDCS_MRP_TimeInterval_Reducer_3 extends Reducer<Text, IntWritable, Text, IntWritable> {
public class TDCS_MRP_TimeInterval_Reducer_5_Filter_VehicleType_Weekday_StartEndGantyrID extends Reducer<Text, Text, Text, Text> {
    
	//private IntWritable result = new IntWritable();
	public void reduce(Text key, Iterable <Text> values, Context context) throws IOException, InterruptedException {
	// public void reduce(Text key, Iterable<IntWritable> values, Context context) throws IOException, InterruptedException {	
	// process values
		final int MinTotalTime = 0;
		final int MaxTotalTime = 120;
		/*
    	 * 
    	 * 31 Fri 05F0528N 00	Total_Min=32##1
		 * 31 Fri 05F0528N 00	Total_Min=34##1
		 * 31 Fri 05F0528N 00	Total_Min=39##1
		 * 31 Fri 05F0528N 00	Total_Min=37##1
		 * 31 Fri 05F0528N 00	Total_Min=36##1
		 * 31 Fri 05F0528N 00	Total_Min=38##1
		 * 31 Fri 05F0528N 00	Total_Min=34##1
		 * 31 Fri 05F0528N 01	Total_Min=35##2
		 * 31 Fri 05F0528N 01	Total_Min=38##1
		 * 31 Fri 05F0528N 02	Total_Min=34##1
		 * 31 Fri 05F0528N 02	Total_Min=36##1
		 * 31 Fri 05F0528N 02	Total_Min=37##2
		 * 31 Fri 05F0528N 02	Total_Min=30##2
    	 */
		  
		String keyStr = key.toString();
		
		String [] InfoItems = keyStr.split(" ");
		//  31 Fri 05F0528N 02	Total_Min=30##2
		
		String OneVehicleType = InfoItems[0];
		String OneWeekday = InfoItems[1];
		String FirstQantryID = InfoItems[2];
		String Hour = InfoItems[3];
		
		//String VehicleType_Hour = OneVehicleType+" "+ Hour;
		String VehicleType_OneWeekday_Hour = OneVehicleType+" "+ OneWeekday+ " "+Hour;
		
		TreeMap TimeIntervalDistribution = new TreeMap<Integer, Integer>();
		TreeMap TimeIntervalDistribution1 = new TreeMap<Integer, Integer>();
		
		//TreeMap TotalTime_WeekdayDistribution = new TreeMap<String, Integer>();
		//TreeMap TotalTime_VehicleTypeDistribution = new TreeMap<String, Integer>();
				
		String Temp = "";
		int SumMin = 0;
		int SumTF = 0;
		int Max = 0;
		int Min = 1000000000;
		
		// key : VehicleTypes Weekday QantryID Hour
		// for key :31 Fri 05F0528N 00
		
		for (Text val : values) {
			/*
	    	 
	    	 * value : "Total_Min="+Integer.toString(TotalTime)+"##"+value(frequency); 
	    	 */
			
			/*
	    	 * Total_Min=32##1
			 * Total_Min=34##1
			 * Total_Min=39##1
			 * Total_Min=37##1
			 * Total_Min=36##1
			 * Total_Min=38##1
			 * Total_Min=34##1
	    	 */
			//context.write(key, val);
			
			Temp = val.toString();
			//String CompositeValue = "Total_Min="+Integer.toString(TotalTime)+"##"+TF+"##"+WeekdayDistribution;
	    	
			String [] Items = Temp.split("##"); // Total_Min=32##1
						
			Integer TotalTime = Integer.valueOf(Items[0].substring(10)); // the remainder substring after "Total_Min="
			if (TotalTime > Max) {
				Max = TotalTime;
			}
			if (TotalTime < Min) {
				Min = TotalTime;
			}
			
			Integer TF = Integer.valueOf(Items[1]);
			
			SumMin = SumMin + TotalTime*TF;
			
			SumTF = SumTF + TF;
			
			if (TimeIntervalDistribution.containsKey(TotalTime)) 
			{
				Integer temp = (int) TimeIntervalDistribution.get(TotalTime) + TF;
				
				TimeIntervalDistribution.put(TotalTime, temp);
				
			} else {
				TimeIntervalDistribution.put(TotalTime, TF);
			}
		} // End of for (Text val : values)
		
		//for (int i=Min; i<=Max;++i) {
		for (int i=MinTotalTime; i<=MaxTotalTime;++i) {
			TimeIntervalDistribution1.put(i, 0);
		}	
		//for (Integer i=Min; i<=Max;++i) {	
		for (int i=MinTotalTime; i<=MaxTotalTime;++i) {
			if (TimeIntervalDistribution.containsKey(i)) {
				Integer temp = (Integer) TimeIntervalDistribution.get(i);
				TimeIntervalDistribution1.put(i,temp);
			}
		} // End of for (int i=Min; i<=Max;++i) 
		
			
		float AvgMin = SumMin/SumTF; 
		
		Set <Integer> Keys = TimeIntervalDistribution1.keySet();	
		String TotalTimeDistribution = "";
		
		for ( Iterator i1 = Keys.iterator(); i1.hasNext();) {
		     Integer onekey = (Integer) i1.next();
		     Integer value =  (Integer) TimeIntervalDistribution1.get(onekey);
		     //System.out.println(key + " = " + value);
		     //TotalTimeDistribution = TotalTimeDistribution+"(" + Integer.toString(onekey)+":"+Integer.toString(value)+")";
		     TotalTimeDistribution = TotalTimeDistribution + ","+ Integer.toString(value);
				
		} // End of for ( Iterator i = Keys.iterator(); i.hasNext();)
		
		
		Text Key = new Text();
		Text Value = new Text();
		
		
		String Result = Integer.toString(SumTF)+"#"
						+Integer.toString(Max)+"#"
						+Integer.toString(Min)+"#"
						+String.valueOf(AvgMin)+"#"
						+TotalTimeDistribution;
				
		Key.set(VehicleType_OneWeekday_Hour);
		Value.set(Result);
		
		context.write(Key, Value);
		//*/
		/*
		int sum = 0;
		for (IntWritable val : values) {
			sum += val.get();
		}
		result.set(sum);
		context.write(key, result);
		*/
	} //End of public void reduce
} // End of public class TDCS_MRP_Reducer extends Reducer
